Attribute VB_Name = "TCP"
Option Explicit

Sub HandleData(rData As String)
'*********************************************
'Handle all data from server
'*********************************************
Dim LoopC As Integer


'***********************
'Connected
'LOGINOK:yourname
'***********************
If Left$(rData, 8) = "LOGINOK:" Then
        UserName = ReadField(2, rData, 58)
         AddtoRichTextBox frmMain.RecTxt, "Logged in as: " & UserName, COLOR_GREEN
        'Gets in that arena
        If UserArena = vbNullString Then
            Call Go(vbNullString)
        Else
            Call Go(UserArena)
        End If
            AddtoRichTextBox frmMain.RecTxt, "Joining Arena: " & UserArena, COLOR_YELLOW
    Exit Sub
End If

'************************************************************
'Failed to login password is wrong or username doesn't exist
'LOGINBAD:message
'************************************************************

If Left$(rData, 9) = "LOGINBAD:" Then
   AddtoRichTextBox frmMain.RecTxt, "Login bad: " & ReadField(2, rData, 58), COLOR_RED
   frmMain.Socket1.Disconnect
    Exit Sub
End If

'***********************
'Arena joined
'INARENA:arenaname:freq
'***********************

If Left$(rData, 8) = "INARENA:" Then
    rData = Right$(rData, Len(rData) - 8)
    
    UserArena = ReadField(1, rData, 58)
    UserFreq = Val(ReadField(2, rData, 58))
    AddtoRichTextBox frmMain.RecTxt, "You have joined arena: " & UserArena & " on freq: " & UserFreq, COLOR_YELLOW
    'Clear's Userlist
    frmMain.UsrLst.ListItems.Clear
    'Clears Status
    UsersOnline = 0
    'Adds Me to list
    UsersOnline = UsersOnline + 1
    'Loads up chats
    Call sendCmd("chat=" & UserChats)
    'Adds my username to player list
    With frmMain.UsrLst.ListItems.Add(1, , UserName, , 9)
    .ListSubItems.Add frmMain.UsrLst.FindItem(UserName).Index, , UserFreq
    End With
    
    frmMain.txtArena.text = UserArena
    frmMain.txtUsers.text = UsersOnline

    Exit Sub
End If

'***********************
'Player list
'PLAYER:name:ship:freq
'***********************

If Left$(rData, 7) = "PLAYER:" Then
    rData = Right$(rData, Len(rData) - 7)
    
    LastUserName = ReadField(1, rData, 58)
    LastUserShip = ReadField(2, rData, 58)
    LastUserFreq = ReadField(3, rData, 58)
    UsersOnline = UsersOnline + 1
    'Adds the name and ship picture
    'Ship 1 = 0
    'Ship 2 = 1
    'Ship 3 = 2
    'Ship 4 = 3
    'Ship 5 = 4
    'Ship 6 = 5
    'Ship 7 = 6
    'Ship 8 = 7
    'Spec X = 8
   
    With frmMain.UsrLst.ListItems.Add(1, , LastUserName, , LastUserShip + 1)
    .ListSubItems.Add frmMain.UsrLst.FindItem(LastUserName).Index, , LastUserFreq
    End With
    
    frmMain.txtArena.text = UserArena
    frmMain.txtUsers.text = UsersOnline

    Exit Sub
End If

'***********************
'Player Entering
'ENTERING:name:ship:freq
'***********************

If Left$(rData, 9) = "ENTERING:" Then
    rData = Right$(rData, Len(rData) - 9)
    LastUserName = ReadField(1, rData, 58)
    LastUserShip = ReadField(2, rData, 58)
    LastUserFreq = ReadField(3, rData, 58)
    UsersOnline = UsersOnline + 1

    With frmMain.UsrLst.ListItems.Add(1, , LastUserName, , LastUserShip + 1)
    .ListSubItems.Add frmMain.UsrLst.FindItem(LastUserName).Index, , LastUserFreq
    End With
    
    'Greet Message
    If UserGreetCheck = 1 Then
        Call sendPub(Variables(UserGreetMsg))
    End If
    
    frmMain.txtArena.text = UserArena
    frmMain.txtUsers.text = UsersOnline
    Exit Sub
End If

'***********************
'Player leaving
'LEAVING:name
'***********************

If Left$(rData, 8) = "LEAVING:" Then
    rData = Right$(rData, Len(rData) - 8)
    
    UsersOnline = UsersOnline - 1
    frmMain.UsrLst.ListItems.Remove frmMain.UsrLst.FindItem(ReadField(1, rData, 58)).Index
    
    frmMain.txtArena.text = UserArena
    frmMain.txtUsers.text = UsersOnline
    Exit Sub
End If

'***********************
'Player changes ship
'SHIPFREQCHANGE:name:ship:freq
'***********************

If Left$(rData, 15) = "SHIPFREQCHANGE:" Then
    rData = Right$(rData, Len(rData) - 15)

    'Removes old index with name,ship,freq
    frmMain.UsrLst.ListItems.Remove frmMain.UsrLst.FindItem(ReadField(1, rData, 58)).Index
    'Adds the name,ship,freq
    With frmMain.UsrLst.ListItems.Add(1, , ReadField(1, rData, 58), , ReadField(2, rData, 58) + 1)
    .ListSubItems.Add frmMain.UsrLst.FindItem(ReadField(1, rData, 58)).Index, , ReadField(3, rData, 58)
    End With
    
    Exit Sub
End If

'***********************
'Kill message
'KILL:killername:killedname:bounty:flagscarried
'***********************

If Left$(rData, 5) = "KILL:" Then
    rData = Right$(rData, Len(rData) - 5)
    If ReadField(4, rData, 58) <> 0 Then
        AddtoRichTextBox frmMain.RecTxt, ReadField(2, rData, 58) & "(" & ReadField(3, rData, 58) & ":" & ReadField(4, rData, 58) & ")" & " killed by: " & ReadField(1, rData, 58), COLOR_GREEN
    Else
        AddtoRichTextBox frmMain.RecTxt, ReadField(2, rData, 58) & "(" & ReadField(3, rData, 58) & ")" & " killed by: " & ReadField(1, rData, 58), COLOR_GREEN
    End If
    Exit Sub
End If


'***********************
'Gets Text
'***********************

If Left$(rData, 4) = "MSG:" Then
    rData = Right$(rData, Len(rData) - 4)

        If Left$(rData, 6) = "ARENA:" And frmOptions.chkMsgArena.value = 1 Then
            rData = Right$(rData, Len(rData) - 6)
            AddtoRichTextBox frmMain.RecTxt, "Arena Message: " & rData, COLOR_GREEN
        
        ElseIf Left$(rData, 4) = "CMD:" And frmOptions.chkMsgCmd.value = 1 Then
            rData = Right$(rData, Len(rData) - 4)
            AddtoRichTextBox frmMain.RecTxt, "Command Message: " & rData, COLOR_GREEN
        
        ElseIf Left$(rData, 4) = "PUB:" And frmOptions.chkMsgPub.value = 1 Then
            rData = Right$(rData, Len(rData) - 4)
            AddtoRichTextBox frmMain.RecTxt, ReadField(1, rData, 58) & "> " & ReadField(2, rData, 58), COLOR_BLUE
            
            If UserBot = 1 Then
            UserCmdPerson = ReadField(1, rData, 58)
                'Bot mode (Public messages only)
                For LoopC = 1 To 10
                    If ReadField(2, rData, 58) = BotMode(LoopC).InCommand And BotMode(LoopC).UseCommand = 1 Then
                        Call sendPub(Variables(BotMode(LoopC).OutCommand))
                        AddtoRichTextBox frmMain.RecTxt, UserName & "> " & Variables(BotMode(LoopC).OutCommand), COLOR_BLUE
                    End If
                Next LoopC
            End If
            
        ElseIf Left$(rData, 5) = "PRIV:" And frmOptions.chkMsgPriv.value = 1 Then
            rData = Right$(rData, Len(rData) - 5)
            AddtoRichTextBox frmMain.RecTxt, "FROM: " & ReadField(1, rData, 58) & "> " & ReadField(2, rData, 58), COLOR_GREEN
        
        ElseIf Left$(rData, 5) = "FREQ:" And frmOptions.chkMsgFreq.value = 1 Then
            rData = Right$(rData, Len(rData) - 5)
            AddtoRichTextBox frmMain.RecTxt, ReadField(1, rData, 58) & "> " & ReadField(2, rData, 58), COLOR_YELLOW
        
        ElseIf Left$(rData, 5) = "CHAT:" And frmOptions.chkMsgChat.value = 1 Then
            rData = Right$(rData, Len(rData) - 5)
            AddtoRichTextBox frmMain.RecTxt, ReadField(1, rData, 58) & "; " & ReadField(2, rData, 58), COLOR_ORANGE
        
        ElseIf Left$(rData, 4) = "MOD:" And frmOptions.chkMsgMod.value = 1 Then
            rData = Right$(rData, Len(rData) - 4)
            AddtoRichTextBox frmMain.RecTxt, "Mod Chat: " & ReadField(1, rData, 58) & "> " & ReadField(2, rData, 58), COLOR_GREEN
        
        ElseIf Left$(rData, 6) = "SYSOP:" And frmOptions.chkMsgSysop.value = 1 Then
            rData = Right$(rData, Len(rData) - 6)
            AddtoRichTextBox frmMain.RecTxt, "Sysop Message: " & ReadField(1, rData, 58) & "> " & ReadField(2, rData, 58), COLOR_GREEN
        
        ElseIf Left$(rData, 6) = "SQUAD:" And frmOptions.chkMsgSquad.value = 1 Then
            rData = Right$(rData, Len(rData) - 6)
            AddtoRichTextBox frmMain.RecTxt, "Squad: (" & ReadField(1, rData, 58) & ") " & ReadField(2, rData, 58) & "> " & ReadField(3, rData, 58), COLOR_GREEN
        End If
    Exit Sub
End If

End Sub

Sub SendData(sdData As String)
'*********************************************
'Attach a ENDC to a string and send to server
'*********************************************
Dim retcode

sdData = sdData & ENDC

'To avoid spam set a limit
If Len(sdData) > 300 Then
    Exit Sub
End If

retcode = frmMain.Socket1.Write(sdData, Len(sdData))

End Sub

Sub Login()
'*********************************************
'Send login strings
'*********************************************

'Pre-saved character
    SendData ("LOGIN:" & Protocol & ":" & UserName & ":" & UserPassword)
End Sub

Sub Go(Name As String)
    SendData ("GO:" & Name)
End Sub

Sub ChangeFreq(Freq As Integer)
    SendData ("CHANGEFREQ:" & Freq)
End Sub

Sub sendPub(Message As String)
    SendData ("SEND:PUB:" & Message)
End Sub

Sub sendPriv(Name As String, Message As String)
    SendData ("SEND:PRIV:" & Name & ":" & Message)
End Sub

Sub sendFreq(Freq As Integer, Message As String)
    SendData ("SEND:FREQ:" & Freq & ":" & Message)
End Sub

Sub sendChat(Channel As String, Message As String)
    SendData ("SEND:CHAT:" & Channel & ";" & Message)
End Sub

Sub sendMod(Message As String)
    SendData ("SEND:MOD:" & Message)
End Sub

Sub sendCmd(Message As String)
    SendData ("SEND:CMD:" & Message)
End Sub

Sub sendPrivCmd(Name As String, Message As String)
    SendData ("SEND:PRIVCMD:" & Name & ":" & Message)
End Sub

Sub sendSquad(Squad As String, Message As String)
    SendData ("SEND:SQUAD:" & Squad & ":" & Message)
End Sub

